local AddonName, AddonTable = ...
local L = AddonTable.Localize
local s = SpellFlashAddon
local a = AddonTable

local parent = AddonName.."_SpellFlashAddonOptionsFrame"
a.OptionsFrame = CreateFrame("Frame", parent, nil, "SpellFlashAddon_OptionsFrameTemplate2")

function a.OptionsFrame.okay()
	s.SetModuleConfig(AddonName, "spell_flashing_off", not _G[parent.."_SpellFlashing"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."LeftCheckButton1"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."RightCheckButton1"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."LeftCheckButton2"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."RightCheckButton2"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."LeftCheckButton3"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."RightCheckButton3"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."LeftCheckButton4"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."RightCheckButton4"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."LeftCheckButton5"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."RightCheckButton5"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."LeftCheckButton6"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."RightCheckButton6"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."LeftCheckButton7"]:GetChecked())
	--s.SetModuleConfig(AddonName, "My_Config_Key", _G[parent.."RightCheckButton7"]:GetChecked())
	if type(a.Spam) == "table" and type(a.Spam[1]) == "table" and type(a.Spam[1].Function) == "function" then
		local Value = _G[parent.."_ScriptSlider"]:GetValue()
		if Value == 1 or type(a.Spam[Value]) ~= "table" or type(a.Spam[Value].Function) ~= "function" then
			Value = nil
		end
		s.SetModuleConfig(AddonName, "script_number", Value)
	end
end

function a.OptionsFrame.refresh()
	_G[parent.."_SpellFlashing"]:SetChecked(not s.GetModuleConfig(AddonName, "spell_flashing_off"))
	--_G[parent.."LeftCheckButton1"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."LeftCheckButton1Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."LeftCheckButton1"]:Show()
	--_G[parent.."RightCheckButton1"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."RightCheckButton1Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."RightCheckButton1"]:Show()
	--_G[parent.."LeftCheckButton2"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."LeftCheckButton2Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."LeftCheckButton2"]:Show()
	--_G[parent.."RightCheckButton2"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."RightCheckButton2Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."RightCheckButton2"]:Show()
	--_G[parent.."LeftCheckButton3"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."LeftCheckButton3Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."LeftCheckButton3"]:Show()
	--_G[parent.."RightCheckButton3"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."RightCheckButton3Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."RightCheckButton3"]:Show()
	--_G[parent.."LeftCheckButton4"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."LeftCheckButton4Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."LeftCheckButton4"]:Show()
	--_G[parent.."RightCheckButton4"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."RightCheckButton4Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."RightCheckButton4"]:Show()
	--_G[parent.."LeftCheckButton5"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."LeftCheckButton5Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."LeftCheckButton5"]:Show()
	--_G[parent.."RightCheckButton5"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."RightCheckButton5Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."RightCheckButton5"]:Show()
	--_G[parent.."LeftCheckButton6"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."LeftCheckButton6Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."LeftCheckButton6"]:Show()
	--_G[parent.."RightCheckButton6"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."RightCheckButton6Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."RightCheckButton6"]:Show()
	--_G[parent.."LeftCheckButton7"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."LeftCheckButton7Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."LeftCheckButton7"]:Show()
	--_G[parent.."RightCheckButton7"]:SetChecked(s.GetModuleConfig(AddonName, "My_Config_Key")) _G[parent.."RightCheckButton7Text"]:SetText(L["My_Check_Button_Label"]) _G[parent.."RightCheckButton7"]:Show()
	if type(a.Spam) == "table" and type(a.Spam[1]) == "table" and type(a.Spam[1].Function) == "function" then
		_G[parent.."_ScriptSlider"]:Show()
		_G[parent.."_ScriptSliderTitle"]:Show()
		_G[parent.."_ScriptSliderDescription"]:Show()
		_G[parent.."_ScriptSliderMinValue"]:Show()
		_G[parent.."_ScriptSliderMaxValue"]:Show()
		_G[parent.."_ScriptSliderValue"]:Show()
		local MaxValue = getn(a.Spam)
		_G[parent.."_ScriptSlider"]:SetMinMaxValues(1, MaxValue)
		_G[parent.."_ScriptSliderMinValueLabel"]:SetText("1")
		_G[parent.."_ScriptSliderMaxValueLabel"]:SetText(""..MaxValue)
		local Value = s.GetModuleConfig(AddonName, "script_number") or 1
		if type(a.Spam[Value]) ~= "table" or type(a.Spam[Value].Function) ~= "function" then
			Value = 1
		end
		_G[parent.."_ScriptSlider"]:SetValue(Value)
		_G[parent.."_ScriptSliderTitleLabel"]:SetText(a.Spam[Value].Title or "")
		_G[parent.."_ScriptSliderDescriptionLabel"]:SetText(a.Spam[Value].Description or "")
		_G[parent.."_ScriptSliderValueLabel"]:SetText(""..Value)
	end
end

function a.OptionsFrame.default()
	s.ClearAllModuleConfigs(AddonName)
end

L["Spell Flashing"] = s.L["Spell Flashing"]
local function LocalizeFontStrings(frame)
	for _, f in next, {frame:GetChildren()} do
		if f:GetObjectType() == "FontString" then
			f:SetText(L[f:GetText()])
		else
			for _, f in next, {f:GetRegions()} do
				if f:GetObjectType() == "FontString" then
					f:SetText(L[f:GetText()])
				end
			end
		end
	end
end
LocalizeFontStrings(a.OptionsFrame)
_G[parent.."TitleString"]:SetText(select(2, GetAddOnInfo(AddonName)).." "..GetAddOnMetadata(AddonName, "Version"))

function a.OptionsFrame.UpdateSliderText(self)
	if self and self:IsVisible() then
		local Value = self:GetValue()
		if type(a.Spam[Value]) ~= "table" or type(a.Spam[Value].Function) ~= "function" then
			Value = 1
		end
		_G[parent.."_ScriptSliderTitleLabel"]:SetText(a.Spam[Value].Title or "")
		_G[parent.."_ScriptSliderDescriptionLabel"]:SetText(a.Spam[Value].Description or "")
		_G[parent.."_ScriptSliderValueLabel"]:SetText(""..Value)
	end
end

function a.RunSpamTable()
	if type(a.Spam) == "table" then
		local i = s.GetModuleConfig(AddonName, "script_number") or 1
		if type(a.Spam[i]) == "table" and type(a.Spam[i].Function) == "function" then
			a.Spam[i].Function()
		elseif type(a.Spam[1]) == "table" and type(a.Spam[1].Function) == "function" then
			s.SetModuleConfig(AddonName, "script_number", nil)
			a.Spam[1].Function()
		end
	end
end

a.OptionsFrame.parent = select(2, GetAddOnInfo("SpellFlash"))
a.OptionsFrame.name = select(2, GetAddOnInfo(AddonName))
InterfaceOptions_AddCategory(a.OptionsFrame)
